CREATE TABLE IF NOT EXISTS `TABLE_GLOBALBLOCKLIST` (
  `id` int(11) NOT NULL auto_increment,
  `u_EMail` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `u_EMail` (`u_EMail`)
);

CREATE TABLE IF NOT EXISTS `TABLE_GLOBALDOMAINBLOCKLIST` (
  `id` int(11) NOT NULL auto_increment,
  `Domainname` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `Domainname` (`Domainname`)
);

CREATE TABLE IF NOT EXISTS `TABLE_MESSAGES` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `Name` varchar(191) NOT NULL,
  `EMailFormatErrorText` mediumtext NOT NULL,
  `RequiredFieldsErrorText` mediumtext NOT NULL,
  `ErrorText` mediumtext NOT NULL,
  `SubscribeOKText` mediumtext NOT NULL,
  `SubscribeTextConfirmationRequired` mediumtext NOT NULL,
  `EMailAddressAlwaysInList` mediumtext NOT NULL,
  `EMailAddressBlacklisted` mediumtext NOT NULL,
  `UnsubscribeOKText` mediumtext NOT NULL,
  `UnsubscribeTextConfirmationRequired` mediumtext NOT NULL,
  `EMailAddressNotInList` mediumtext NOT NULL,
  `SubscribeTextOnConfirmationSucc` mediumtext NOT NULL,
  `UnsubscribeTextOnConfirmationSucc` mediumtext NOT NULL,
  `SubscribeTextOnConfirmationFailure` mediumtext NOT NULL,
  `UnsubscribeTextOnConfirmationFailure` mediumtext NOT NULL,
  `SubscribeTextOnConfirmationAgain` mediumtext NOT NULL,
  `CaptchaStringIncorrect` mediumtext NOT NULL,
  `GroupsAsMandatoryFieldError` mediumtext NOT NULL,
  `PrivacyPolicyAcceptanceError` mediumtext NOT NULL,
  `u_EMail` mediumtext NOT NULL,
  `u_EMailFormat` mediumtext NOT NULL,
  `u_CustomerNo` mediumtext NOT NULL,
  `u_Firm` mediumtext NOT NULL,
  `u_Gender` mediumtext NOT NULL,
  `u_Salutation` mediumtext NOT NULL,
  `u_Profession` mediumtext NOT NULL,
  `u_FirstName` mediumtext NOT NULL,
  `u_MiddleName` mediumtext NOT NULL,
  `u_LastName` mediumtext NOT NULL,
  `u_CellNumber` mediumtext NOT NULL,
  `u_Birthday` mediumtext NOT NULL,
  `u_MessengerICQ` mediumtext NOT NULL,
  `u_MessengerMSN` mediumtext NOT NULL,
  `u_MessengerYAHOO` mediumtext NOT NULL,
  `u_MessengerAOL` mediumtext NOT NULL,
  `u_MessengerOther` mediumtext NOT NULL,
  `u_PrivateStreet` mediumtext NOT NULL,
  `u_PrivateZIPCode` mediumtext NOT NULL,
  `u_PrivateCity` mediumtext NOT NULL,
  `u_PrivateState` mediumtext NOT NULL,
  `u_PrivateCountry` mediumtext NOT NULL,
  `u_PrivateWebsite` mediumtext NOT NULL,
  `u_PrivateTelephone` mediumtext NOT NULL,
  `u_PrivateFax` mediumtext NOT NULL,
  `u_BusinessStreet` mediumtext NOT NULL,
  `u_BusinessZIPCode` mediumtext NOT NULL,
  `u_BusinessCity` mediumtext NOT NULL,
  `u_BusinessState` mediumtext NOT NULL,
  `u_BusinessCountry` mediumtext NOT NULL,
  `u_BusinessWebsite` mediumtext NOT NULL,
  `u_BusinessTelephone` mediumtext NOT NULL,
  `u_BusinessFax` mediumtext NOT NULL,
  `u_BusinessPosition` mediumtext NOT NULL,
  `u_BusinessDepartment` mediumtext NOT NULL,
  `u_Comments` mediumtext NOT NULL,
  `u_Username` mediumtext NOT NULL,
  `u_Password` mediumtext NOT NULL,
  `u_Language` mediumtext NOT NULL,
  `u_UserFieldString1` mediumtext NOT NULL,
  `u_UserFieldString2` mediumtext NOT NULL,
  `u_UserFieldString3` mediumtext NOT NULL,
  `u_UserFieldInt1` mediumtext NOT NULL,
  `u_UserFieldInt2` mediumtext NOT NULL,
  `u_UserFieldInt3` mediumtext NOT NULL,
  `u_UserFieldBool1` mediumtext NOT NULL,
  `u_UserFieldBool2` mediumtext NOT NULL,
  `u_UserFieldBool3` mediumtext NOT NULL,
  `u_PersonalizedTracking` mediumtext NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_FUNCTIONS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `Name` varchar(191) NOT NULL,
  `functiontext` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_TARGETGROUPS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `Name` varchar(191) NOT NULL,
  `functiontext` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_MTAS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `Type` enum('mail','sendmail','smtp','smtpmx', 'savetodir') NOT NULL,
  `Name` varchar(191) NOT NULL,
  `MailLimit` bigint(20) NOT NULL default '0',
  `SleepInMailSendingLoop` int(2) NOT NULL default '0',
  `MTASenderEMailAddress` varchar(255) NOT NULL default '',
  `PHPMailParams` varchar(255) NOT NULL,
  `HELOName` varchar(255) NOT NULL default 'localhost',
  `SMTPPersist` tinyint(1) NOT NULL default '0',
  `SMTPPipelining` tinyint(1) NOT NULL default '0',
  `SMTPTimeout` int(4) NOT NULL default '20',
  `SMTPServer` varchar(255) NOT NULL,
  `SMTPPort` int(2) NOT NULL default '25',
  `SMTPAuth` tinyint(1) NOT NULL default '0',
  `SMTPUsername` varchar(255) NOT NULL,
  `SMTPPassword` varchar(255) NOT NULL,
  `SMTPSSL` tinyint(1) NOT NULL default '0',

  `OAuth2Apps_id` int(11) NOT NULL default '0',

  `sendmail_path` varchar(255) NOT NULL default '/usr/sbin/sendmail',
  `sendmail_args` varchar(255) NOT NULL default '-i',
  `savetodir_pathname` varchar(255) NOT NULL,

  `MailThreadCount` int(4) NOT NULL default '1',
  `MaxMailsPerThread` int(4) NOT NULL default '2',


  `MailHeaderFields` text,
  `SMIMESignMail` tinyint(1) NOT NULL default '0',
  `SMIMEMessageAsPlainText` tinyint(1) NOT NULL default '1',
  `SMIMESignCert` text,
  `SMIMESignPrivKey` text,
  `SMIMESignPrivKeyPassword` text,
  `SMIMESignExtraCerts` text,
  `SMIMEIgnoreSignErrors` tinyint(1) NOT NULL default '0',
  `DKIM` tinyint(1) NOT NULL default '0',
  `DomainKey` tinyint(1) NOT NULL default '0',
  `DKIMSelector` varchar(255) NOT NULL default '',
  `DKIMPrivKey` text,
  `DKIMPrivKeyPassword` text,
  `DKIMIgnoreSignErrors` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `Type` (`Type`),
  KEY `Name` (`Name`),
  KEY `users_id` (`CreateDate`)
);

CREATE TABLE IF NOT EXISTS `TABLE_PAGES` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `Name` varchar(191) NOT NULL,
  `Type` enum('Subscribe','Unsubscribe','Error','SubscribeConfirmation','UnsubscribeConfirmation','UnsubscribeBridge','Edit','EditConfirmation','EditReject','EditError','RFUSurveyConfirmation') NOT NULL,
  `RedirectURL` varchar(255) NOT NULL,
  `ForceRedirect` tinyint(1) NOT NULL default '0',
  `HTMLPage` mediumtext NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Type` (`Type`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_TEMPLATES` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `IsWizardable` tinyint(1) NOT NULL default '0',
  `UsersOption` tinyint(1) NOT NULL default '0',
  `Name` varchar(191) NOT NULL,
  `MailFormat` enum('PlainText','HTML','Multipart') NOT NULL default 'HTML',
  `MailPlainText` mediumtext NOT NULL,
  `MailHTMLText` mediumtext NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_TEMPLATESTOUSERS` (
  `templates_id` int(11) NOT NULL,
  `users_id` int(11) NOT NULL,
  KEY `templates_id` (`templates_id`, `users_id`)
);

CREATE TABLE IF NOT EXISTS `TABLE_INBOXES` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `Name` varchar(64) NOT NULL,
  `InboxType` enum('pop3','imap') NOT NULL,
  `EMailAddress` varchar(255) NOT NULL,
  `Servername` varchar(255) NOT NULL,
  `Serverport` int(11) NOT NULL default '110',
  `Username` varchar(255) NOT NULL,
  `Password` varchar(255) NOT NULL,
  `SSL` tinyint(1) NOT NULL default '0',

  `OAuth2Apps_id` int(11) NOT NULL default '0',

  `LeaveMessagesInInbox` tinyint(1) NOT NULL default '0',
  `SubscriptionSubject` varchar(255) NOT NULL,
  `SubscriptionConfirmSubject` varchar(255) NOT NULL,
  `UnsubscriptionSubject` varchar(255) NOT NULL,
  `EditSubject` varchar(255) NOT NULL,
  `UIDL` LONGTEXT NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_AUTORESPONDERS` (
  `id` int(11) NOT NULL AUTO_INCREMENT ,
  `CreateDate` DATETIME NOT NULL ,
  `IsActive` tinyint(1) NOT NULL default '0',
  `NoTiming` tinyint(1) NOT NULL default '1',
  `TimingFrom` time NOT NULL default '00:00:00',
  `TimingTo` time NOT NULL default '00:00:00',
  `TimingMultipleDayNames` set('every day','0','1','2','3','4','5','6') NOT NULL default 'every day',
  `Name` varchar(191) NOT NULL,

  `AnswerHeaderField` enum('ReturnPath','From','ReplyTo') NOT NULL default 'ReturnPath',
  `UnseenMsgsOnly` tinyint(1) NOT NULL default '0',

  `NoAnswerOnMemberExists` tinyint(1) NOT NULL default '0',
  `IgnoreHeaderXLoop` tinyint(1) NOT NULL default '1',
  `AddXLoop` tinyint(1) NOT NULL default '1',
  `AutoresponderLimit` tinyint(1) NOT NULL default '0',
  `AutoresponderLimitPerDay` int(11) NOT NULL default '3',
  `AddListUnsubscribe` tinyint(1) NOT NULL default '1',
  `mtas_id` int(11) NOT NULL,
  `inboxes_id` int(11) NOT NULL,
  `maillists_id` int(11) default 0,
  `forms_id` int(11) NOT NULL default '1',
  `UserMailHeaderFields` text,
  `ResponderUIDL` longtext NOT NULL,
  `EMailAnswerSubjects` text,
  `EMailsProcessed` int(11) default 0,
  `HardBouncesCount` int(11) NOT NULL default '0',
  `SoftBouncesCount` int(11) NOT NULL default '0',
  `UnsubscribesCount` int(11) NOT NULL default '0',
  `MaxEMailsToProcess` int(11) NOT NULL default '50',
  `SenderFromName` varchar(255) NOT NULL,
  `SenderFromAddress` varchar(255) NOT NULL,
  `ReplyToEMailAddress` varchar(255) NOT NULL,
  `ReturnPathEMailAddress` varchar(255) NOT NULL,
  `CcEMailAddresses` text NOT NULL,
  `BCcEMailAddresses` text NOT NULL,
  `ReturnReceipt` tinyint(1) NOT NULL default '0',
  `BCCSending` tinyint(1) NOT NULL default '0',
  `BCCRecipientsCount` tinyint(4) NOT NULL default '10',
  `BCCSenderEMailAddress` varchar(255) NOT NULL,
  `MailFormat` enum('PlainText','HTML','Multipart') NOT NULL default 'Multipart',
  `MailPriority` enum('Low','Normal','High') NOT NULL default 'Normal',
  `MailEncoding` varchar(20) NOT NULL default 'iso-8859-1',
  `MailSubject` varchar(255) NOT NULL,
  `MailPreHeaderText` varchar(255) NOT NULL,
  `MailPlainText` mediumtext NOT NULL,
  `MailHTMLText` mediumtext NOT NULL,
  `Attachments` mediumtext NOT NULL,
  `Caching` tinyint(1) NOT NULL default '1',
  PRIMARY KEY ( `id` ) ,
  KEY ( `mtas_id` ),
  KEY ( `inboxes_id` ),
  KEY ( `maillists_id` ),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_AUTORESPONDERS_STATISTICS` (
  `id` int(11) NOT NULL auto_increment,
  `autoresponders_id` int(11) NOT NULL,
  `MailSubject` varchar(255) NOT NULL,
  `SendDateTime` datetime NOT NULL,
  `recipients_id` int(11) NOT NULL,
  `EMail` varchar(255) NOT NULL,
  `IsSMS` tinyint(1) NOT NULL default '0',
  `Send` enum('Prepared','Sent','Failed','PossiblySent','Hardbounced') NOT NULL default 'Prepared',
  `SendResult` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY (`autoresponders_id`),
  KEY (`EMail`),
  KEY (`recipients_id`)
);


CREATE TABLE IF NOT EXISTS `TABLE_FOLLOWUPRESPONDERS` (
  `id` int(11) NOT NULL AUTO_INCREMENT ,
  `CreateDate` DATETIME NOT NULL ,
  `IsActive` tinyint(1) NOT NULL default '0',
  `ResponderType` int(1) default 0,
  `SendTimeVariant` enum('sendingWithoutSendTime','sendingWithSendTime') NOT NULL default 'sendingWithoutSendTime',
  `SendTime` time NOT NULL,
  `Name` varchar(191) NOT NULL,
  `AddXLoop` tinyint(1) NOT NULL default '1',
  `AddListUnsubscribe` tinyint(1) NOT NULL default '1',
  `MaxEMailsToProcess` int(11) NOT NULL default '200',
  `mtas_id` int(11) NOT NULL,
  `maillists_id` int(11) default 0,
  `forms_id` int(11) NOT NULL default '1',
  `GroupsTableName` varchar(255) NOT NULL,
  `NotInGroupsTableName` varchar(255) NOT NULL,
  `StartDateOfFirstFUMail` int(1) default 0,
  `FirstFollowUpMailDateFieldName` varchar(255) NOT NULL,
  `FormatOfFirstFollowUpMailDateField` varchar(64) NOT NULL,
  `OnFollowUpDoneAction` INT NOT NULL default '1',
  `OnFollowUpDoneCopyToMailList` int(11) NOT NULL default '0',
  `OnFollowUpDoneMoveToMailList` int(11) NOT NULL default '0',
  `OnFollowUpDoneScriptURL` varchar(255) NOT NULL,
  `EMailsSent` int(11) default 0,
  `HardBouncesCount` int(11) NOT NULL default '0',
  `SoftBouncesCount` int(11) NOT NULL default '0',
  `UnsubscribesCount` int(11) NOT NULL default '0',
  `SenderFromName` varchar(255) NOT NULL,
  `SenderFromAddress` varchar(255) NOT NULL,
  `ReplyToEMailAddress` varchar(255) NOT NULL,
  `ReturnPathEMailAddress` varchar(255) NOT NULL,
  `FUMailsTableName` varchar(255) NOT NULL,
  `ML_FU_RefTableName` varchar(255) NOT NULL,
  `RStatisticsTableName` varchar(255) NOT NULL,
  `PersonalizeEMails` tinyint(1) NOT NULL default '1',
  `TrackLinks` tinyint(1) NOT NULL default '0',
  `TrackLinksByRecipient` tinyint(1) NOT NULL default '0',
  `TrackEMailOpenings` tinyint(1) NOT NULL default '0',
  `TrackEMailOpeningsByRecipient` tinyint(1) NOT NULL default '0',
  `TrackingIPBlocking` tinyint(1) NOT NULL default '0',
  `GoogleAnalyticsActive` tinyint(1) NOT NULL default '0',
  `GoogleAnalytics_utm_source` varchar(255) NOT NULL,
  `GoogleAnalytics_utm_medium` varchar(255) NOT NULL,
  `GoogleAnalytics_utm_term` varchar(255) NOT NULL,
  `GoogleAnalytics_utm_content` varchar(255) NOT NULL,
  `GoogleAnalytics_utm_campaign` varchar(255) NOT NULL,
  PRIMARY KEY ( `id` ) ,
  KEY ( `mtas_id` ),
  KEY ( `maillists_id` ),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_BIRTHDAYMAILS` (
  `id` int(11) NOT NULL AUTO_INCREMENT ,
  `CreateDate` DATETIME NOT NULL ,
  `IsActive` tinyint(1) NOT NULL default '0',
  `SendIntervalDays` int(11) NOT NULL default '0',
  `SendTime` time NOT NULL,
  `Name` varchar(191) NOT NULL,
  `AddXLoop` tinyint(1) NOT NULL default '1',
  `AddListUnsubscribe` tinyint(1) NOT NULL default '1',
  `MaxEMailsToProcess` int(11) NOT NULL default '200',
  `mtas_id` int(11) NOT NULL,
  `maillists_id` int(11) default 0,
  `forms_id` int(11) NOT NULL default '1',
  `UserMailHeaderFields` text NOT NULL,
  `EMailsSent` int(11) default 0,
  `HardBouncesCount` int(11) NOT NULL default '0',
  `SoftBouncesCount` int(11) NOT NULL default '0',
  `UnsubscribesCount` int(11) NOT NULL default '0',
  `SenderFromName` text NOT NULL,
  `SenderFromAddress` text NOT NULL,
  `ReplyToEMailAddress` text NOT NULL,
  `ReturnPathEMailAddress` text NOT NULL,
  `CcEMailAddresses` text NOT NULL,
  `BCcEMailAddresses` text NOT NULL,
  `ReturnReceipt` tinyint(1) NOT NULL default '0',
  `BCCSending` tinyint(1) NOT NULL default '0',
  `BCCRecipientsCount` tinyint(4) NOT NULL default '10',
  `BCCSenderEMailAddress` text NOT NULL,

  `MailEditType` enum('Editor','Wizard') NOT NULL default 'Editor',
  `WizardHTMLText` mediumtext NOT NULL,

  `MailFormat` enum('PlainText','HTML','Multipart') NOT NULL default 'Multipart',
  `MailPriority` enum('Low','Normal','High') NOT NULL default 'Normal',
  `MailEncoding` varchar(20) NOT NULL default 'iso-8859-1',
  `MailSubject` text NOT NULL,
  `MailPreHeaderText` text NOT NULL,
  `MailPlainText` mediumtext NOT NULL,
  `MailHTMLText` mediumtext NOT NULL,
  `Attachments` mediumtext NOT NULL,
  `Caching` tinyint(1) NOT NULL default '1',
  `ML_BM_RefTableName` text NOT NULL,
  `LinksTableName` text NOT NULL,
  `TrackingOpeningsTableName` text NOT NULL,
  `TrackingOpeningsByRecipientTableName` text NOT NULL,
  `TrackingLinksTableName` text NOT NULL,
  `TrackingLinksByRecipientTableName` text NOT NULL,
  `TrackingUserAgentsTableName` text NOT NULL,
  `TrackingOSsTableName` text NOT NULL,
  `TrackEMailOpeningsImageURL` text NOT NULL,
  `TrackEMailOpeningsByRecipientImageURL` text NOT NULL,
  `PersonalizeEMails` tinyint(1) NOT NULL default '1',
  `TrackLinks` tinyint(1) NOT NULL default '0',
  `TrackLinksByRecipient` tinyint(1) NOT NULL default '0',
  `TrackEMailOpenings` tinyint(1) NOT NULL default '0',
  `TrackEMailOpeningsByRecipient` tinyint(1) NOT NULL default '0',
  `TrackingIPBlocking` tinyint(1) NOT NULL default '0',
  `GoogleAnalyticsActive` tinyint(1) NOT NULL default '0',
  `GoogleAnalytics_utm_source` text NOT NULL,
  `GoogleAnalytics_utm_medium` text NOT NULL,
  `GoogleAnalytics_utm_term` text NOT NULL,
  `GoogleAnalytics_utm_content` text NOT NULL,
  `GoogleAnalytics_utm_campaign` text NOT NULL,
  `SMSoutUsername` text NOT NULL,
  `SMSoutPassword` text NOT NULL,
  `SMSSendOptions` tinyint(4) NOT NULL default '0',
  `SMSoutSendVariant` tinyint(4) NOT NULL default '1',
  `SMSText` text NOT NULL,
  PRIMARY KEY ( `id` ) ,
  KEY ( `mtas_id` ),
  KEY ( `maillists_id` ),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_BIRTHDAYMAILS_STATISTICS` (
  `id` int(11) NOT NULL auto_increment,
  `birthdayresponders_id` int(11) NOT NULL,
  `MailSubject` varchar(255) NOT NULL,
  `SendDateTime` datetime NOT NULL,
  `recipients_id` int(11) NOT NULL,
  `EMail` varchar(255) NOT NULL,
  `IsSMS` tinyint(1) NOT NULL default '0',
  `Send` enum('Prepared','Sent','Failed','PossiblySent','Hardbounced') NOT NULL default 'Prepared',
  `SendResult` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY (`birthdayresponders_id`),
  UNIQUE `recipients_idbirthdayresponders_id_IsSMS` (`recipients_id`, `birthdayresponders_id`, `IsSMS`)
);

CREATE TABLE IF NOT EXISTS `TABLE_CAMPAIGNS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `LastSentDateTime` datetime NOT NULL,
  `SetupLevel` tinyint(2) NOT NULL default '0',
  `ReSendFlag` tinyint(1) NOT NULL default '0',
  `Creator_users_id` int(11) NOT NULL,
  `maillists_id` int(11) NOT NULL,
  `forms_id` int(11) NOT NULL default '1',
  `UserMailHeaderFields` text NOT NULL,

  `CurrentSendTableName` text NOT NULL,
  `CurrentUsedMTAsTableName` text NOT NULL,
  `ArchiveTableName` text NOT NULL,

  `SendRules` text NOT NULL,
  `DestCampaignAction` tinyint(1) NOT NULL default '0',
  `DestCampaignActionId` int(11) NOT NULL default '0',
  `DestCampaignActionSentEntry_id` int(11) NOT NULL default '0',
  `DestCampaignActionLastRecipientsAction` enum('WasSent','WasNotSent','WasOpened','WasNotOpened','HasLinkClicked','HasSpecialLinkClicked','HasNoLinkClicked','HasSpecialLinkNotClicked') NOT NULL default 'WasSent',
  `DestCampaignActionLastRecipientsActionLink_id` int(11) NOT NULL default '0',

  `GroupsTableName` text NOT NULL,
  `NotInGroupsTableName` text NOT NULL,
  `MTAsTableName` text NOT NULL,
  `RStatisticsTableName` text NOT NULL,
  `LinksTableName` text NOT NULL,
  `TrackingOpeningsTableName` text NOT NULL,
  `TrackingOpeningsByRecipientTableName` text NOT NULL,
  `TrackingLinksTableName` text NOT NULL,
  `TrackingLinksByRecipientTableName` text NOT NULL,
  `TrackingUserAgentsTableName` text NOT NULL,
  `TrackingOSsTableName` text NOT NULL,


  `Name` varchar(191) NOT NULL,
  `Description` text NOT NULL,
  `MaxEMailsToProcess` int(11) NOT NULL default '200',

  `current_edit_users_id` int(11) NOT NULL default '0',
  `current_edit_datetime` datetime NOT NULL,

  `LiveSendingBreakCount` int(11) NOT NULL default '0',
  `LiveSendingBreakTime` int(11) NOT NULL default '0',

  `SendReportToYourSelf` tinyint(1) NOT NULL default '0',
  `SendReportToListAdmin` tinyint(1) NOT NULL default '0',
  `SendReportToMailingListUsers` tinyint(1) NOT NULL default '0',
  `SendReportToEMailAddress` tinyint(1) NOT NULL default '0',
  `SendReportToEMailAddressEMailAddress` text NOT NULL,
  `PersonalizeEMails` tinyint(1) NOT NULL default '1',
  `TrackLinks` tinyint(1) NOT NULL default '0',
  `TrackLinksByRecipient` tinyint(1) NOT NULL default '0',
  `TrackEMailOpenings` tinyint(1) NOT NULL default '0',
  `TrackEMailOpeningsByRecipient` tinyint(1) NOT NULL default '0',
  `TrackEMailOpeningsImageURL` text NOT NULL,
  `TrackEMailOpeningsByRecipientImageURL` text NOT NULL,
  `TrackingIPBlocking` tinyint(1) NOT NULL default '0',
  `GoogleAnalyticsActive` tinyint(1) NOT NULL default '0',
  `GoogleAnalytics_utm_source` text NOT NULL,
  `GoogleAnalytics_utm_medium` text NOT NULL,
  `GoogleAnalytics_utm_term` text NOT NULL,
  `GoogleAnalytics_utm_content` text NOT NULL,
  `GoogleAnalytics_utm_campaign` text NOT NULL,
  `SendScheduler` enum('SaveOnly','SendManually','SendImmediately','SendInFutureOnce','SendInFutureMultiple') NOT NULL default 'SaveOnly',

  `SendTimeNotLimited` tinyint(1) NOT NULL default '1',
  `SendTimeFrom` time NOT NULL default '00:00:00',
  `SendTimeTo` time NOT NULL default '00:00:00',
  `SendTimeMultipleDayNames` set('every day','0','1','2','3','4','5','6') NOT NULL default 'every day',

  `SendInFutureOnceDateTime` datetime NOT NULL,
  `SendInFutureMultipleDays` set('none','every day','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23','24','25','26','27','28','29','30','31') NOT NULL default 'none',
  `SendInFutureMultipleDayNames` set('none','every day','0','1','2','3','4','5','6') NOT NULL default 'none',
  `SendInFutureMultipleMonths` set('none','every month','1','2','3','4','5','6','7','8','9','10','11','12') NOT NULL default 'none',
  `SendInFutureMultipleTime` time NOT NULL default '00:00:00',
  `SenderFromName` text NOT NULL,
  `SenderFromAddress` text NOT NULL,
  `ReplyToEMailAddress` text NOT NULL,
  `ReturnPathEMailAddress` text NOT NULL,
  `CcEMailAddresses` text NOT NULL,
  `BCcEMailAddresses` text NOT NULL,
  `ReturnReceipt` tinyint(1) NOT NULL default '0',
  `BCCSending` tinyint(1) NOT NULL default '0',
  `BCCRecipientsCount` tinyint(4) NOT NULL default '10',
  `BCCSenderEMailAddress` text NOT NULL,
  `UseInternalText` tinyint(1) NOT NULL default '1',
  `ExternalTextURL` text NOT NULL,
  `MailEditType` enum('Editor','Wizard','PlainSource') NOT NULL default 'Editor',
  `WizardHTMLText` mediumtext NOT NULL,
  `MailFormat` enum('PlainText','HTML','Multipart') NOT NULL default 'Multipart',
  `MailPriority` enum('Low','Normal','High') NOT NULL default 'Normal',
  `MailEncoding` varchar(20) NOT NULL default 'iso-8859-1',
  `MailSubject` text NOT NULL,
  `MailPreHeaderText` text NOT NULL,
  `MailPlainText` mediumtext NOT NULL,
  `MailHTMLText` mediumtext NOT NULL,
  `Attachments` mediumtext NOT NULL,
  `PersAttachments` mediumtext NOT NULL,
  `SendEMailWithoutPersAttachment` tinyint(1) NOT NULL default '1',
  `AutoCreateTextPart` tinyint(1) NOT NULL default '1',
  `Caching` tinyint(1) NOT NULL default '1',
  `AddXLoop` tinyint(1) NOT NULL default '0',
  `AddListUnsubscribe` tinyint(1) NOT NULL default '1',
  `TwitterUpdate` tinyint(1) NOT NULL default '0',
  `TwitterUsername` text NOT NULL,
  `TwitterPassword` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_NEWSLETTERARCHIVES` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsActive` tinyint(1) NOT NULL default '1',
  `UniqueID` text NOT NULL,
  `Name` varchar(191) NOT NULL,
  `Description` text NOT NULL,
  `OpeningsCount` bigint(20) NOT NULL default '0',
  `TemplatesPath` text NOT NULL,
  `CampaignToNATableName` text NOT NULL,
  `SortOrderNewToOld` tinyint(1) NOT NULL default '1',

  `StartPageTitle` text NOT NULL,
  `StartPageHeadline` text NOT NULL,

  `StartPageLogo` text NOT NULL,
  `StartPageSubHeadline1` text NOT NULL,
  `StartPageSubHeadline2` text NOT NULL,
  `ImpressumHeadline` text NOT NULL,
  `YearsPrefix` text NOT NULL,
  `NewsletterEntryPrefix` text NOT NULL,

  `InfoBarActive` tinyint(1) NOT NULL default '1',
  `InfoBarSchemeColorName` text NOT NULL,
  `InfoBarSrcLanguage` text NOT NULL,
  `InfoBarSpacer` text NOT NULL,
  `InfoBarSupportedTranslationLanguages` mediumtext NOT NULL,
  `InfoBarLinksArray` mediumtext NOT NULL,

  `MaxLatestEntriesOnStartPage` int(11) NOT NULL default '3',
  `ShowSelectedEntryFirst` tinyint(1) NOT NULL default '1',

  `StartPageShowSubscribeLink` tinyint(1) NOT NULL default '1',

  `ShowImpressum` tinyint(1) NOT NULL default '0',
  `ImpressumIsHTML` tinyint(1) NOT NULL default '0',
  `ImpressumText` text NOT NULL,

  `PlaceHoldersAction` tinyint(1) NOT NULL default '1',
  `PlaceHolderReplacements` text NOT NULL,

  `LinkToSWM` tinyint(1) NOT NULL default '1',
  `RemoveMailToLinks` tinyint(1) NOT NULL default '0',

  `HeadDescription` text NOT NULL,
  `HeadKeywords` text NOT NULL,
  `HeadAutor` text NOT NULL,

  `rssshowAll` tinyint(1) NOT NULL default '0',
  `rssTitle` text NOT NULL,
  `rssLinkURL` text NOT NULL,
  `rssDescription` text NOT NULL,
  `rssCopyright` text NOT NULL,

  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_MAILSSENTTABLENAME` (
  `id` int(11) NOT NULL auto_increment,
  `MailDate` date NOT NULL,
  `TestEMailCount` int(11) unsigned NOT NULL default '0',
  `AdminNotifyMailCount` int(11) unsigned NOT NULL default '0',
  `OptInConfirmationMailCount` int(11) unsigned NOT NULL default '0',
  `OptInConfirmedMailCount` int(11) unsigned NOT NULL default '0',
  `OptOutConfirmationMailCount` int(11) unsigned NOT NULL default '0',
  `OptOutConfirmedMailCount` int(11) unsigned NOT NULL default '0',
  `EditConfirmationMailCount` int(11) unsigned NOT NULL default '0',
  `EditConfirmedMailCount` int(11) unsigned NOT NULL default '0',
  `AutoresponderEMailCount` int(11) unsigned NOT NULL default '0',
  `BirthdayResponderEMailCount` int(11) unsigned NOT NULL default '0',
  `RSS2EMailResponderEMailCount` int(11) unsigned NOT NULL default '0',
  `FollowUpResponderEMailCount` int(11) unsigned NOT NULL default '0',
  `EventResponderEMailCount` int(11) unsigned NOT NULL default '0',
  `CampaignEMailCount` int(11) unsigned NOT NULL default '0',
  `DistribListEMailCount` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `MailDate` (`MailDate`)
);

CREATE TABLE IF NOT EXISTS `TABLE_RSS2EMAILMAILS` (
  `id` int(11) NOT NULL AUTO_INCREMENT ,
  `CreateDate` DATETIME NOT NULL ,
  `IsActive` tinyint(1) NOT NULL default '0',
  `SendScheduler` enum('SendOnNewPosts','SendAtDay','SendOnceAMonth') NOT NULL default 'SendAtDay',
  `SendOnNewPostsCount` tinyint(2) NOT NULL default '1',
  `SendDayNames` enum('every day','0','1','2','3','4','5','6') NOT NULL default 'every day',
  `SendMonthDay` enum('none','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23','24','25','26','27','28','29','30','31') NOT NULL default 'none',
  `SendTime` time NOT NULL,
  `Name` varchar(191) NOT NULL,
  `AddXLoop` tinyint(1) NOT NULL default '1',
  `AddListUnsubscribe` tinyint(1) NOT NULL default '1',
  `MaxEMailsToProcess` int(11) NOT NULL default '200',
  `mtas_id` int(11) NOT NULL,
  `maillists_id` int(11) default 0,
  `forms_id` int(11) NOT NULL default '1',
  `RSSFeedURL` text NOT NULL,
  `RSSFeedMaxEntriesToRetrieve` int(11) default 20,
  `EverSendLastRSSFeedMaxEntries` tinyint(1) NOT NULL default '0',
  `LastRSSFeedContent` longtext NOT NULL,
  `LastRSSFeedContentRetrieved` datetime NOT NULL,
  `LastRSSFeedContentProcessed` tinyint(1) NOT NULL default '1',
  `UserMailHeaderFields` text NOT NULL,
  `EMailsSent` int(11) default 0,
  `HardBouncesCount` int(11) NOT NULL default '0',
  `SoftBouncesCount` int(11) NOT NULL default '0',
  `UnsubscribesCount` int(11) NOT NULL default '0',
  `SenderFromName` text NOT NULL,
  `SenderFromAddress` text NOT NULL,
  `ReplyToEMailAddress` text NOT NULL,
  `ReturnPathEMailAddress` text NOT NULL,
  `CcEMailAddresses` text NOT NULL,
  `BCcEMailAddresses` text NOT NULL,
  `ReturnReceipt` tinyint(1) NOT NULL default '0',
  `BCCSending` tinyint(1) NOT NULL default '0',
  `BCCRecipientsCount` tinyint(4) NOT NULL default '10',
  `BCCSenderEMailAddress` text NOT NULL,
  `MailFormat` enum('PlainText','HTML','Multipart') NOT NULL default 'Multipart',
  `MailPriority` enum('Low','Normal','High') NOT NULL default 'Normal',
  `MailEncoding` varchar(20) NOT NULL default 'iso-8859-1',
  `MailSubject` text NOT NULL,
  `MailPreHeaderText` text NOT NULL,
  `MailPlainText` mediumtext NOT NULL,
  `MailHTMLText` mediumtext NOT NULL,
  `Attachments` mediumtext NOT NULL,
  `Caching` tinyint(1) NOT NULL default '1',
  `ML_RM_RefTableName` text NOT NULL,

  `GroupsTableName` text NOT NULL,
  `NotInGroupsTableName` text NOT NULL,

  `LinksTableName` text NOT NULL,
  `TrackingOpeningsTableName` text NOT NULL,
  `TrackingOpeningsByRecipientTableName` text NOT NULL,
  `TrackingLinksTableName` text NOT NULL,
  `TrackingLinksByRecipientTableName` text NOT NULL,
  `TrackingUserAgentsTableName` text NOT NULL,
  `TrackingOSsTableName` text NOT NULL,
  `TrackEMailOpeningsImageURL` text NOT NULL,
  `TrackEMailOpeningsByRecipientImageURL` text NOT NULL,
  `PersonalizeEMails` tinyint(1) NOT NULL default '1',
  `TrackLinks` tinyint(1) NOT NULL default '0',
  `TrackLinksByRecipient` tinyint(1) NOT NULL default '0',
  `TrackEMailOpenings` tinyint(1) NOT NULL default '0',
  `TrackEMailOpeningsByRecipient` tinyint(1) NOT NULL default '0',
  `TrackingIPBlocking` tinyint(1) NOT NULL default '0',
  `GoogleAnalyticsActive` tinyint(1) NOT NULL default '0',
  `GoogleAnalytics_utm_source` text NOT NULL,
  `GoogleAnalytics_utm_medium` text NOT NULL,
  `GoogleAnalytics_utm_term` text NOT NULL,
  `GoogleAnalytics_utm_content` text NOT NULL,
  `GoogleAnalytics_utm_campaign` text NOT NULL,
  PRIMARY KEY ( `id` ) ,
  KEY ( `mtas_id` ),
  KEY ( `maillists_id` ),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_RSS2EMAILMAILS_STATISTICS` (
  `id` int(11) NOT NULL auto_increment,
  `rss2emailresponders_id` int(11) NOT NULL,
  `MailSubject` varchar(255) NOT NULL,
  `SendDateTime` datetime NOT NULL,
  `recipients_id` int(11) NOT NULL,
  `EMail` varchar(255) NOT NULL,
  `Send` enum('Prepared','Sent','Failed','PossiblySent','Hardbounced') NOT NULL default 'Prepared',
  `SendResult` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY (`rss2emailresponders_id`)
);

CREATE TABLE IF NOT EXISTS `TABLE_AUTOIMPORTS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `Name` varchar(191) NOT NULL,
  `IsActive` tinyint(1) NOT NULL default '1',
  `maillists_id` int(11) default 0,

  `LastImportDate` datetime NOT NULL,
  `LastImportDone` tinyint(1) NOT NULL default '1',

  `LastImportRemoveMode` tinyint(1) NOT NULL default '0',

  `LastRowCount` int(11) NOT NULL default '0',
  `LastImportRowCount` int(11) NOT NULL default '0',

  `LastStartPosition` int(11) NOT NULL default '0',
  `LastFilePosition` int(11) NOT NULL default '0',
  `LastTablePosition` int(11) NOT NULL default '0',

  `ImportScheduler` enum('ImportAtDay','ImportOnceAMonth') NOT NULL default 'ImportAtDay',
  `ImportDayNames` enum('every day','0','1','2','3','4','5','6') NOT NULL default 'every day',
  `ImportMonthDay` enum('none','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23','24','25','26','27','28','29','30','31') NOT NULL default 'none',
  `ImportTime` time NOT NULL,

  `ImportOption` enum('ImportCSV','ImportDB') NOT NULL default 'ImportCSV',
  `ImportFilename` varchar(255) NOT NULL,

  `Separator` varchar(16) NOT NULL default ',',
  `Header1Line` tinyint(1) NOT NULL default '1',
  `RemoveQuotes` tinyint(1) NOT NULL default '1',
  `RemoveSpaces` tinyint(1) NOT NULL default '1',
  `RemoveFile` tinyint(1) NOT NULL default '0',
  `ImportLines` int(11) NOT NULL default '100',
  `IsUTF8` tinyint(1) NOT NULL default '1',
  `ImportBlockedRecipients` tinyint(1) NOT NULL default '0',
  `CreateErrorLog` tinyint(1) NOT NULL default '0',
  `SendOptInEMail` tinyint(1) NOT NULL default '0',
  `BirthdayDateFormat` varchar(32) NOT NULL,
  `IsMacFile` tinyint(1) NOT NULL default '0',

  `RemoveAllRecipients` tinyint(1) NOT NULL default '0',

  `fields` text NOT NULL,
  `GroupsOption` int(1) NOT NULL default '1',
  `ImportGroupField` int(11) NOT NULL,
  `groups_id` int(11) NOT NULL,
  `ExImportOption` int(1) NOT NULL default '1',
  `RemoveRecipientFromGroups` int(1) NOT NULL default '0',

  `DBType` enum('MYSQL','MSSQL') NOT NULL default 'MYSQL',
  `SQLServerName` varchar(255) NOT NULL,
  `SQLDatabase` varchar(255) NOT NULL,
  `SQLUsername` varchar(255) NOT NULL,
  `SQLPassword` varchar(255) NOT NULL,
  `SQLTableName` varchar(255) NOT NULL,
  `SQLExtImport` int(1) NOT NULL default '1',
  `SQLImportSQLQuery` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`),
  KEY `maillists_id` (`maillists_id`)
);

CREATE TABLE IF NOT EXISTS `TABLE_TEXTBLOCKS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `Name` varchar(191) NOT NULL,
  `textblocktext` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);


CREATE TABLE IF NOT EXISTS `TABLE_SPLITTESTS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `SetupLevel` tinyint(2) NOT NULL default '0',
  `ReSendFlag` tinyint(1) NOT NULL default '0',
  `Creator_users_id` int(11) NOT NULL,
  `maillists_id` int(11) NOT NULL,
  `forms_id` int(11) NOT NULL default '1',
  `Name` varchar(191) NOT NULL,
  `Description` text NOT NULL,
  `CurrentSendTableName` varchar(255) NOT NULL,
  `SplitTestCurrentSendIdToCampaignsCurrentSendIdTableName` varchar(255) NOT NULL,
  `CampaignsForSplitTestTableName` varchar(255) NOT NULL,
  `SendScheduler` enum('SaveOnly','SendImmediately','SendInFutureOnce') NOT NULL default 'SaveOnly',
  `SendInFutureOnceDateTime` datetime NOT NULL,
  `WinnerType` enum('WinnerOpens','WinnerClicks') NOT NULL default 'WinnerClicks',
  `TestType` enum('TestSendToAllMembers','TestSendToListPercentage') NOT NULL default 'TestSendToAllMembers',
  `ListPercentage` int(11) NOT NULL default 10,
  `SendAfterInterval` int(11) NOT NULL default 12,
  `SendAfterIntervalType` enum('Minute','Hour','Day') NOT NULL default 'Hour',
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);


CREATE TABLE IF NOT EXISTS `TABLE_SMSCAMPAIGNS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `SetupLevel` tinyint(2) NOT NULL default '0',
  `ReSendFlag` tinyint(1) NOT NULL default '0',
  `Creator_users_id` int(11) NOT NULL,
  `maillists_id` int(11) NOT NULL,
  `forms_id` int(11) NOT NULL default '1',
  `CurrentSendTableName` varchar(255) NOT NULL,
  `SendRules` text NOT NULL,
  `GroupsTableName` varchar(255) NOT NULL,
  `NotInGroupsTableName` varchar(255) NOT NULL,
  `RStatisticsTableName` varchar(255) NOT NULL,
  `Name` varchar(191) NOT NULL,
  `Description` text NOT NULL,
  `MaxSMSToProcess` int(11) NOT NULL default '50',
  `SendReportToYourSelf` tinyint(1) NOT NULL default '0',
  `SendReportToListAdmin` tinyint(1) NOT NULL default '0',
  `SendReportToMailingListUsers` tinyint(1) NOT NULL default '0',
  `SendReportToEMailAddress` tinyint(1) NOT NULL default '0',
  `SendReportToEMailAddressEMailAddress` varchar(255) NOT NULL,
  `PersonalizeSMS` tinyint(1) NOT NULL default '1',
  `SendScheduler` enum('SaveOnly','SendManually','SendImmediately','SendInFutureOnce','SendInFutureMultiple') NOT NULL default 'SaveOnly',
  `SendInFutureOnceDateTime` datetime NOT NULL,
  `SendInFutureMultipleDays` set('none','every day','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23','24','25','26','27','28','29','30','31') NOT NULL default 'none',
  `SendInFutureMultipleDayNames` set('none','every day','0','1','2','3','4','5','6') NOT NULL default 'none',
  `SendInFutureMultipleMonths` set('none','every month','1','2','3','4','5','6','7','8','9','10','11','12') NOT NULL default 'none',
  `SendInFutureMultipleTime` time NOT NULL default '00:00:00',
  `SMSServiceURL` varchar(255) NOT NULL,
  `SMSoutUsername` varchar(255) NOT NULL,
  `SMSoutPassword` varchar(255) NOT NULL,
  `UseInternalText` tinyint(1) NOT NULL default '1',
  `ExternalTextURL` varchar(255) NOT NULL,
  `SMSSendVariant` int(1) NOT NULL default '1',
  `SMSText` mediumtext NOT NULL,
  `SMSCampaignName` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_DISTRIB_LISTS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsActive` tinyint(1) NOT NULL default '1',
  `Creator_users_id` int(11) NOT NULL,
  `Name` varchar(191) NOT NULL,
  `Description` text NOT NULL,

  `WorkAsRealMailingList` tinyint(1) NOT NULL default '0',

  `EMailsProcessed` int(11) NOT NULL default '0',
  `EMailsSent` int(11) default 0,

  `maillists_id` int(11) NOT NULL,
  `forms_id` int(11) NOT NULL default '1',
  `inboxes_id` int(11) NOT NULL,
  `LeaveMessagesInInbox` tinyint(1) NOT NULL default '0',

  `ResponderUIDL` longtext NOT NULL,

  `DistribListSubjects` text NOT NULL,
  `MaxEMailsToProcess` int(11) NOT NULL default '1',

  `SendConfirmationRequired` tinyint(1) NOT NULL default '1',
  `AcceptAllSenderEMailAddresses` int(1) NOT NULL default '1',
  `AcceptSenderEMailAddresses` text NOT NULL,
  `SendInfoMailToSender` tinyint(1) NOT NULL default '1',
  `SendConfirmationLinkToThisEMailAddresses` text NOT NULL,

  `ModifiedEMailSubject` text NOT NULL,
  `DontModifyEMailSubjectOnReFw` tinyint(1) NOT NULL default '0',
  `NoPOSTToDistributionList` tinyint(1) NOT NULL default '0',

  `AutoRemoveEMails` tinyint(1) NOT NULL default '0',
  `AutoRemoveEMailDays` int(11) NOT NULL default '30',

  `UserMailHeaderFields` text NOT NULL,

  `CurrentSendTableName` text NOT NULL,
  `CurrentUsedMTAsTableName` text NOT NULL,

  `GroupsTableName` text NOT NULL,
  `NotInGroupsTableName` text NOT NULL,
  `MTAsTableName` text NOT NULL,
  `RStatisticsTableName` text NOT NULL,

  `LinksTableName` text NOT NULL,
  `TrackingOpeningsTableName` text NOT NULL,
  `TrackingOpeningsByRecipientTableName` text NOT NULL,
  `TrackingLinksTableName` text NOT NULL,
  `TrackingLinksByRecipientTableName` text NOT NULL,
  `TrackingUserAgentsTableName` text NOT NULL,
  `TrackingOSsTableName` text NOT NULL,

  `MaxEMailsToSend` int(11) NOT NULL default '100',
  `MaxEMailSize` int(11) NOT NULL default '10485760',

  `SendReportToDistribSenderEMailAddress` tinyint(1) NOT NULL default '0',
  `SendReportToYourSelf` tinyint(1) NOT NULL default '0',
  `SendReportToListAdmin` tinyint(1) NOT NULL default '0',
  `SendReportToMailingListUsers` tinyint(1) NOT NULL default '0',
  `SendReportToEMailAddress` tinyint(1) NOT NULL default '0',
  `SendReportToEMailAddressEMailAddress` text NOT NULL,

  `PersonalizeEMails` tinyint(1) NOT NULL default '1',
  `TrackLinks` tinyint(1) NOT NULL default '0',
  `TrackLinksByRecipient` tinyint(1) NOT NULL default '0',
  `TrackEMailOpenings` tinyint(1) NOT NULL default '0',
  `TrackEMailOpeningsByRecipient` tinyint(1) NOT NULL default '0',
  `TrackEMailOpeningsImageURL` text NOT NULL,
  `TrackEMailOpeningsByRecipientImageURL` text NOT NULL,
  `TrackingIPBlocking` tinyint(1) NOT NULL default '0',
  `GoogleAnalyticsActive` tinyint(1) NOT NULL default '0',
  `GoogleAnalytics_utm_source` text NOT NULL,
  `GoogleAnalytics_utm_medium` text NOT NULL,
  `GoogleAnalytics_utm_term` text NOT NULL,
  `GoogleAnalytics_utm_content` text NOT NULL,
  `GoogleAnalytics_utm_campaign` text NOT NULL,

  `OverwriteSenderAddress` tinyint(1) NOT NULL default '0',
  `SenderFromName` text NOT NULL,
  `SenderFromAddress` text NOT NULL,
  `ReplyToEMailAddress` text NOT NULL,
  `ReturnPathEMailAddress` text NOT NULL,
  `CcEMailAddresses` text NOT NULL,
  `BCcEMailAddresses` text NOT NULL,
  `ReturnReceipt` tinyint(1) NOT NULL default '0',
  `BCCSending` tinyint(1) NOT NULL default '0',
  `BCCRecipientsCount` tinyint(4) NOT NULL default '10',
  `BCCSenderEMailAddress` text NOT NULL,

  `MailPreHeaderText` text NOT NULL,

  `AutoCreateTextPart` tinyint(1) NOT NULL default '0',
  `Caching` tinyint(1) NOT NULL default '1',
  `IgnoreHeaderXLoop` tinyint(1) NOT NULL default '1',
  `AddXLoop` tinyint(1) NOT NULL default '1',
  `AddListUnsubscribe` tinyint(1) NOT NULL default '1',

  `NoEMailToDistribSenderEMailAddress` tinyint(1) NOT NULL default '0',

  `DistribListConfirmationLinkMailSubject` text NOT NULL,
  `DistribListConfirmationLinkMailPlainText` mediumtext NOT NULL,
  `DistribListSenderInfoMailSubject` text NOT NULL,
  `DistribListSenderInfoMailPlainText` mediumtext NOT NULL,
  `DistribListSenderInfoConfirmMailSubject` text NOT NULL,
  `DistribListSenderInfoConfirmMailPlainText` mediumtext NOT NULL,

  `AddSignature` tinyint(1) NOT NULL default '0',
  `SignatureHTMLText` mediumtext NOT NULL,
  `SignaturePlainText` mediumtext NOT NULL,

  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_DISTRIB_LISTS_ENTRIES` (
  `id` int(11) NOT NULL auto_increment,
  `DistribList_id` int(11) NOT NULL,
  `CreateDate` datetime NOT NULL,

  `DistribSenderEMailAddress` text NOT NULL,

  `DistribSenderFromToCC` mediumtext NOT NULL,

  `SendConfirmationString` text NOT NULL,

  `SendScheduler` enum('ConfirmationPending','SaveOnly','SendImmediately','Sent') NOT NULL default 'SaveOnly',

  `SenderFromName` text NOT NULL,
  `SenderFromAddress` text NOT NULL,
  `ReplyToEMailAddress` text NOT NULL,
  `ReturnPathEMailAddress` text NOT NULL,
  `CcEMailAddresses` text NOT NULL,
  `BCcEMailAddresses` text NOT NULL,
  `ReturnReceipt` tinyint(1) NOT NULL default '0',
  `BCCSending` tinyint(1) NOT NULL default '0',
  `BCCRecipientsCount` tinyint(4) NOT NULL default '10',
  `BCCSenderEMailAddress` text NOT NULL,

  `UseInternalText` tinyint(1) NOT NULL default '1',
  `ExternalTextURL` text NOT NULL,

  `MailFormat` enum('PlainText','HTML','Multipart') NOT NULL default 'Multipart',
  `MailPriority` enum('Low','Normal','High') NOT NULL default 'Normal',
  `MailEncoding` varchar(20) NOT NULL default 'iso-8859-1',
  `MailSubject` text NOT NULL,
  `MailPlainText` mediumtext NOT NULL,
  `MailHTMLText` mediumtext NOT NULL,
  `Attachments` mediumtext NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `DistribList_id` (`DistribList_id`),
  KEY `SendConfirmationString` (`SendConfirmationString`(255))
);

CREATE TABLE IF NOT EXISTS `TABLE_LIMITSUBUNSUBSCRIPTS` (
  `CreateDate` datetime NOT NULL,
  `IP` varchar(64) default NULL,
  KEY `CreateDate` (`CreateDate`),
  KEY `IP` (`IP`)
);

CREATE TABLE IF NOT EXISTS `TABLE_OAUTH2APPS` (
  `id` int(11) NOT NULL auto_increment,
  `AppName` text NOT NULL,

  `AuthorizationEndpoint` text NOT NULL,
  `AccessTokenEndpoint` text NOT NULL,
  `LogoutEndpoint` text NOT NULL,
  `RevokeEndpoint` text NOT NULL,

  `ClientID` text NOT NULL,
  `ClientSecret` text NOT NULL,

  `Scope` text NOT NULL,

  `redirect_uri` text NOT NULL,

  `AdditionalAuthorizationURLParams` text NOT NULL,
  `AdditionalChangeAuthCodeToAccessTokenURLParams` text NOT NULL,

  `ServerInfo` mediumtext NOT NULL,
  PRIMARY KEY  (`id`)
);


CREATE TABLE IF NOT EXISTS `TABLE_OAUTH2CLIENTTOKENS` (
  `id` int(11) NOT NULL auto_increment,
  `OAuth2Apps_id` int(11) NOT NULL,
  `ClientAccountEMailAddress` varchar(255) NOT NULL,

  `access_token` mediumtext NOT NULL,
  `access_token_expires` datetime NOT NULL,

  `refresh_token` mediumtext NOT NULL,

  `scope` mediumtext NOT NULL,

  `token_type` VARCHAR(32) NOT NULL default 'Bearer',

  `ts` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),

  PRIMARY KEY  (`id`),
  UNIQUE KEY `OAuth2Apps_id_ClientAccountEMailAddress` (`OAuth2Apps_id`, `ClientAccountEMailAddress`(191))
);


